/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales;

import com.rjconsultores.ventaboletos.entidad.MotivoReimpresion;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderMotivoReimpresion;
import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Rafius
 */
@Controller("busquedaMotivoReimpresionController")
@Scope("prototype")
public class BusquedaMotivoReimpresionController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<MotivoReimpresion> plwMotivoReimpresion;
    private MyListbox motivoReimpresionList;
    private Paging pagingMotivoReimpresion;
    private Textbox txtNombre;

    public Paging getPagingMotivoReimpresion() {
        return pagingMotivoReimpresion;
    }

    public void setPagingMotivoReimpresion(Paging pagingMotivoReimpresion) {
        this.pagingMotivoReimpresion = pagingMotivoReimpresion;
    }

    public MyListbox getMotivoReimpresionList() {
        return motivoReimpresionList;
    }

    public void setMotivoReimpresionList(MyListbox motivoReimpresionList) {
        this.motivoReimpresionList = motivoReimpresionList;
    }

    public PagedListWrapper<MotivoReimpresion> getPlwMotivoReimpresion() {
        return plwMotivoReimpresion;
    }

    public void setPlwMotivoReimpresion(PagedListWrapper<MotivoReimpresion> plwMotivoReimpresion) {
        this.plwMotivoReimpresion = plwMotivoReimpresion;
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verPeriodo(new MotivoReimpresion());
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        motivoReimpresionList.setItemRenderer(new RenderMotivoReimpresion());
        motivoReimpresionList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                MotivoReimpresion mr = (MotivoReimpresion) motivoReimpresionList.getSelected();
                verPeriodo(mr);
            }
        });

        refreshLista();

        txtNombre.focus();
    }

    private void verPeriodo(MotivoReimpresion mr) {
        if (mr == null) {
            return;
        }

        Map args = new HashMap();
        args.put("motivoReimpresion", mr);
        args.put("motivoReimpresionList", motivoReimpresionList);

        openWindow("/gui/configuraciones_comerciales/editarMotivoReimpresion.zul",
                Labels.getLabel("editarMotivoReimpresionController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<MotivoReimpresion> claseServicioBusqueda =
                new HibernateSearchObject<MotivoReimpresion>(MotivoReimpresion.class, pagingMotivoReimpresion.getPageSize());

        claseServicioBusqueda.addFilterLike("descmotivo", "%" + txtNombre.getText().trim().concat("%"));
        claseServicioBusqueda.addFilterEqual("activo", true);
        claseServicioBusqueda.addSortAsc("descmotivo");

        plwMotivoReimpresion.init(claseServicioBusqueda, motivoReimpresionList, pagingMotivoReimpresion);

        if (motivoReimpresionList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaMotivoReimpresionController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }
}
